#!/usr/local/bin/perl

$file1 = $ARGV[0];
$file2 = $ARGV[1];

open(FILE1, $file1) || die ("Could not open file...");
open(FILE2, $file2) || die ("Could not open file...");

@splitArray = ();
%file1Hash;
%file2Hash;
$count = 0;
$temp = 0;

# Set up first Hash Table
while(<FILE1>)
{
    chomp;
    $_ = lc($_);
    $_ =~ s/\./ \. /g;
    $_ =~ s/\?/ \? /g;
    $_ =~ s/\!/ \! /g;
    $_ =~ s/\"//g;
    $_ =~ s/\,/ \, /g;
    $_ =~ s/\;/ \; /g;
    $_ =~ s/\*/ \* /g;
    $_ =~ s/\:/ \: /g;
    $_ =~ s/\-/ \- /g;

    @splitArray = split(/\s+/,$_);

    foreach $word (@splitArray)
    {
	$file1Hash{$word}++;
	$count++;
    }
}

foreach $word (keys %file1Hash)
{
    $file1Hash{$word} = $file1Hash{$word} / $count;
}

@splitArray = ();
$count = 0;

# Set up second Hash Table
while(<FILE2>)
{
    chomp;
    $_ = lc($_);
    $_ =~ s/\./ \. /g;
    $_ =~ s/\?/ \? /g;
    $_ =~ s/\!/ \! /g;
    $_ =~ s/\"/ /g;
    $_ =~ s/\,/ \, /g;
    $_ =~ s/\;/ \; /g;
    $_ =~ s/\*/ \* /g;
    $_ =~ s/\:/ \: /g;
    $_ =~ s/\-/ \- /g;

    @splitArray = split(/\s+/,$_);

    foreach $word (@splitArray)
    {
	$file2Hash{$word}++;
	$count++;
    }
}

foreach $word (keys %file2Hash)
{
    $file2Hash{$word} = $file2Hash{$word} / $count;
}


# Cross Entropy Calculations
$totalEntropy = 0;

foreach $word (keys %file1Hash)
{
    if(defined $file2Hash{$word})
    {
	#print $word,"\n";
	#print "File1Hash = $file1Hash{$word}\n";
	#print "File2Hash = $file2Hash{$word}\n";
	
	$temp =
	    $file1Hash{$word} * (log ($file1Hash{$word} / 
				      $file2Hash{$word}) / log(2));

	#print "Calculation = $temp\n";

	$totalEntropy += $temp;
    }
}

print $totalEntropy,"\n";


