#!/usr/local/bin/perl

$file = $ARGV[0];
$scoringProgram = $ARGV[1];
$dictionary = $ARGV[2];
$report = $ARGV[3];

open(FILE, $file) || die ("Cannot open $file...\n");

@splitArray = ();
@bigArray = ();
@tempArray = ();
@capitals = ('A','B','C','D','E','F','G','H','I','J','K',
	     'L','M','N','O','P','Q','R','S','T','U','V',
	     'W','X','Y','Z');

@entropyArray = ();
@usedLetterArray = ();

$finalTruth = 0;
$letterTruth = 0;
$usedTruth = 0;
$lcCounter = 0;
$bigCounter = 0;

%entropyHash;
%emptyHash;

while(<FILE>)
{
    $_ =~ s/\s+/ /g;
    @splitArray = split(//,$_);
    
    foreach $word (@splitArray)
    {
	push(@bigArray, $word);
    }
}

# I have bigArray before starting
while($bigCounter <= $#bigArray)
{
    while($bigArray[$bigCounter] eq ' ')
    {
	$bigCounter++;

	if($bigCounter == $#bigArray)
	{
	    print "Printing final text to CryptoOutput.txt\n";
	    open(OUT, ">CryptoOutput.txt");

	    $stringOut = join("",@bigArray);
	    print OUT $stringOut;
	    exit;
	}
    }

    # Sets up letterTruth
    # 1 if the letter at bigCounter is a capital
    # 0 if the letter at bigCounter is not a capital
    foreach $letter (@capitals)
    {
	if($bigArray[$bigCounter] eq $letter)
	{
	    $letterTruth = 1;
	}
    }
    
    # If it is a capital, go on to next letter and reset letterTruth
    if($letterTruth == 1)
    {
	$bigCounter++;
	$letterTruth = 0;
    }
    # Else the letter at bigCounter is a lowercase
    # Do substitution algorithm
    else
    {
	$bigString = join("",@bigArray);
	foreach $letter (@capitals)
	{
	    foreach $thing (@usedLetterArray)
	    {
		if($thing eq $letter)
		{
		    $usedTruth = 1;
		}
	    }
	    
	    if($usedTruth == 0)
	    {
		if($report == 1)
		{
		    print "Calculating $letter.....\n";
		}

		open(TEMPFILE, ">tempFile.txt");
		
		$tempString = $bigString;
		$tempString =~ s/$bigArray[$bigCounter]/$letter/g;
		
		print TEMPFILE $tempString;
		close(TEMPFILE);

		$calculation = `perl $scoringProgram tempFile.txt $dictionary`;

		if($report == 1)
		{
		    print "   --> $calculation";
		}

		push(@entropyArray,$calculation);
		$entropyHash{$letter} = $calculation;
		
		$tempString = $bigString;
	    }
	    $usedTruth = 0;
	}
	foreach $letter (sort {$entropyHash{$b} <=> $entropyHash{$a}} keys %entropyHash)
	{
	    $bigString =~ s/$bigArray[$bigCounter]/$letter/g;
	    
	    if($report == 1)
	    {
		print "bigString = $bigString\n";
	    }

	    @bigArray = split(//,$bigString);
	    
	    if($report == 1)
	    {
		print "Next letter replaced with $letter\n";
	    }

	    push(@usedLetterArray, $letter);
	    
	    $bigCounter++;
	    %entropyHash = %emptyHash;
	    last;
	}	
    }
    $usedTruth = 0;
}

print "Printing final text to CryptoOutput.txt\n";
open(OUT, ">CryptoOutput.txt");

$stringOut = join("",@bigArray);
print OUT $stringOut;
