#!/usr/local/bin/perl

#################################################
#                                               #
#     Scott Daniels                             #
#     CS5761 : Natural Language Processing      #
#     Program Assignment 4 : Random Speech      #
#                                               #
#################################################


# File Handling counter
$numberArgs = $#ARGV;

open(FILE2, ">SevengramText.txt");

# If just one text
if($numberArgs == 2)
{
    open(FILE, "$ARGV[2]") || die "Could not open file\n";
}
# If more than one text
else
{
    # Open temporary file to write to
    open(FILE, ">CatFile.txt");
    $index = 2;

    # Look at each file starting with the first and ending
    # at the last file


    while($index <= $#ARGV)
    {
        # Open file to DST
	open(DST, $ARGV[$index]) || die "Could not open file\n";
        # Write every line of file into FILE ("CatFile.txt")
	while(<DST>)
        {
	    print FILE $_;
	}
	$index++;
    }
}

# If more than one file, open CatFile
if($#ARGV > 2)
{
    open(FILE, "CatFile.txt");
}


# Get Command Line Arguments for calculations
$gramNumber = $ARGV[0];
$numberOfSentences = $ARGV[1];

@wordArray = ();
@sentenceArray = ();
@totalSentencesArray = ();



# Construct the startString depending on Gram #
$startString = "";
for($index=0; $index < ($gramNumber-1); $index++)
{
    $startString = $startString."<start> ";
}

# Insert beginning <start>s
for($index=0; $index < ($gramNumber-1); $index++)
{
    push(@wordArray,"<start>");
}

# Takes in from file and splits into individual words and 
# punctuation. Ex: I, went, to, the, store, .,
# Also inserts <start>s accordingly
while(<FILE>)
{   
    chomp; 
    $_ = lc($_);

    # Puts a period after the end of each line
    $_ = $_." . ";

    # Puts spaces before the punctuation marks
    $_ =~ s/[.!?,;]/ $&/g;

    # Inserts proper number of starts after ending punctuation
    $_ =~ s/\./. $startString/g;
    $_ =~ s/\?/? $startString/g;
    $_ =~ s/\!/! $startStrint/g;
    
    $_ =~ s/\s+/ /g;
    $_ =~ s/^\s+//g; 
    $_ =~ s/\s+$//g;

    push(@wordArray,split(/\s+/,$_));
}

# Set up the Hash tables fullGram and halfGram
%halfGram;
%fullGram;
$tempString = "";

# Set up dual hashes for the appropriate words in the text
for($index=0; $index <= $#wordArray; $index++)
{   
    for($index2=0; $index2 <= ($gramNumber-2); $index2++)
    {
	$tempString = $tempString." ".$wordArray[$index+$index2];
    }
    substr($tempString,0,1) = '';
    
    $halfGram{$tempString}++;
    $tempString = "";
    
    for($index2=0; $index2 <= ($gramNumber-1); $index2++)
    {
	$tempString = $tempString." ".$wordArray[$index+$index2];
    }
    substr($tempString,0,1) = '';

    $fullGram{$tempString}++;
    $tempString = "";
}

# Set up hashes and variables for index calculation
%unigramHash;
%calculationHash;
%emptyHash;
$calculation = 0;
$finalString = "";
$stringCount = 0;

# Set up final string to be <start> .... accordingly
for(0..($gramNumber-2))
{
    $finalString = $finalString."<start> ";
}
$stringCount = length($finalString);

# Initialize the flag and counter for sentences
$exitFlag = 0;
$sentenceCounter = 1;

# If a unigram
if($gramNumber == 1)
{
    # Put each word from text into a hash and increment value
    foreach $word (@wordArray)
    {
	$unigramHash{$word}++;
    }

    # Do while the number of sentences is not reached
    while($sentenceCounter <= $numberOfSentences)
    {
	# print "Sentence $sentenceCounter:  ";

	# While the last word is not a . ? or !
	while($exitFlag == 0)
	{
	    # Set up calculations for the keys without the candidate
	    foreach $unigramKey (keys %unigramHash)
	    {
		$calculation = $unigramHash{$unigramKey} / $#wordArray;
		$calculationHash{$unigramKey} = $calculation;
	    }
	    
	    # Pick a random number
	    $randomNumber = rand(1);
	    $previousValue = 0;
	    
	    # Make a hash of probablities and find the word corresponding
	    # to the random number generated
	    foreach $word (sort{$calculationHash{$b}<=>$calculationHash{$a}}
			   %calculationHash)
	    {
		# If the random number is not in the field of the percentage
		if(($previousValue + $calculationHash{$word}) < $randomNumber)
		{
		    $previousValue = $calculationHash{$word} + $previousValue;
		}
		# If the random number is in the field of the percentage
		else
		{
		    # Append word to the final string
		    $finalString = $finalString." $word";

		    # Check to see if last word is a punctuation mark and set the
		    # flag accordingly
		    if($word eq "." || $word eq "?" || $word eq "!")
		    {
			$exitFlag = 1;
		    }
		    last;
		}	 
	    }	
	    
	    # Reset the calculation hash
	    %calculationHash = %emptyHash;
	}
	
	# Print the final string after finding a punctuation mark
	substr($finalString,0,$stringCount+1) = '';
	print "$finalString\n";
	
	print FILE2 "$finalString\n";

	# Reset data for next sentence
	$finalString = "";
	$exitFlag = 0;
	$sentenceCounter++;
    }
}
# If not a unigram
else
{
    # Do while the number of sentences is not reached
    while($sentenceCounter <= $numberOfSentences)
    {
	#print "Sentence $sentenceCounter:  ";
	
	# While the last word is not a . ? or !
	while($exitFlag == 0) 
	{
	    # Get the last appropriate words from the finalString
	    @tempArray = split(/\s+/,$finalString);
	    for($index=$#tempArray-($gramNumber-2); $index <= $#tempArray; $index++)
	    {
		$tempString = $tempString." ".$tempArray[$index];
	    }
	    substr($tempString,0,1) = '';
	    
	    # Set up calculations for the keys without the candidate
	    foreach $fullKey (keys %fullGram)
	    {
		# If the full key is found in the tempString just constructed
		# add that value to the calculation list
		if($fullKey =~ m/^$tempString\s/)
		{
		    # Set up calculation hash with probablitly values
		    $calculation = $fullGram{$fullKey} / $halfGram{$tempString};
		    substr($fullKey,0,length($tempString)+1) = '';
		    $calculationHash{$fullKey} = $calculation;
		}
	    }
	    
	    # Reset tempString and find a random number
	    $tempString = "";
	    $randomNumber = rand(1);
	    $previousValue = 0;
	    
            # Make a hash of probablities and find the word corresponding
	    # to the random number generated	    
	    foreach $word (sort{$calculationHash{$b}<=>$calculationHash{$a}}
			   %calculationHash)
	    {
		# If the random number is not in the field of the percentage
		if(($previousValue + $calculationHash{$word}) < $randomNumber)
		{
		    $previousValue = $calculationHash{$word} + $previousValue;
		}
		# If the random number is in the field of the percentage
		else
		{
		    # Append the found word to the final string
		    $finalString = $finalString." $word";
		    
		    # Check for punctuation and set flag accordingly
		    if($word eq "." || $word eq "?" || $word eq "!")
		    {
			$exitFlag = 1;
		    }
		    last;
		}	    
	    }	
	    
	    # Clear calculation hash
	    %calculationHash = %emptyHash;
	}
	
	# Print the final string generated after punctuation
	substr($finalString,0,$stringCount+1) = '';
	print "$finalString\n";

	# Print to file
	print FILE2 "$finalString\n";
	
	# Reset data for next sentence
	$finalString = "";
	for(0..($gramNumber-2))
	{
	    $finalString = $finalString."<start> ";
	}
	$exitFlag = 0;
	$sentenceCounter++;
    }
}
