#!/usr/local/bin/perl

#################################################
#                                               #
#     Scott Daniels                             #
#     CS5761 : Natural Language Processing      #
#     Program Assignment 2 : Texts              #
#                                               #
#################################################

open(FILE2, ">CutVoynich.txt");

# File Handling counter
$numberArgs = $#ARGV;

# If just one text
if($numberArgs == 2)
{
    open(FILE, "$ARGV[2]") || die "Could not open file\n";
}
# If more than one text
else
{
    # Open temporary file to write to
    open(FILE, ">CatFile.txt");
    $index = 2;

    # Look at each file starting with the first and ending
    # at the last file
    while($index <= $#ARGV)
    {
        # Open file to DST
	open(DST, $ARGV[$index]) || die "Could not open file\n";
        # Write every line of file into FILE ("CatFile.txt")
	while(<DST>)
        {
	    print FILE $_;
	}
	$index++;
    }
}

# If more than one file, open CatFile
if($#ARGV > 2)
{
    open(FILE, "CatFile.txt");
}

# Variable setup
$rankNumber = $ARGV[0];
$rankCounter = 1;
$percentText = $ARGV[1];
@splitArray = "";
@totalWords = "";
$wordCounter = 0;
$tempWord = "";
%hashTable = ();
%uniqueHash = ();
$printCounter = 2;
$types = 0;
$frequency = 0;
$lowerTypes = 0;
$percent = 0;
$k = 0;

$count = 0;
# While loop create totalWords
while(<FILE>)
{
    $count++;
    # Delete page numbers and remove periods
    chomp;
    $_ =~ s/\./ /g;
    $_ =~ s/<.*>//g;
    $_ =~ s/^\s+//g;
    $_ =~ s/\s+$//g;
    $_ =~ s/\,/ /g;
    $_ =~ s/\=/ /g;
    $_ =~ s/\-/ /g;
    $_ =~ s/\:/ /g;
    $_ =~ s/\;/ /g;
    $_ =~ s/\/ /g;

    # Letters used:       oehyacdiklrstnqpmf*gxvz 
    # Letters not used:   bjux

    print FILE2 "$_\n";

    # Split on whitespace
    @splitArray = split(/\s+/,$_);

    # For every word, lowercase it and put it in a array
    foreach $word (@splitArray)
    {
	$tempWord = lc($word);
	push(@totalWords,$tempWord);
	$wordCounter = $wordCounter + 1;
    }

}

# Calculate the splitIndex from arguments and reset counter
$splitIndex = $wordCounter * ((100-$percentText)/100);
$wordCounter = 0;

# For each word in the totalWord array 
# Setup hash Tables
foreach $word (@totalWords)
{
    
# If it is before the cutoff put in big hash table
    if($wordCounter < $splitIndex)
    {
	$hashTable{$word}++;
    }
    # If it is after the cutoff
    else
    {
	# If the word is already in the big hash, put in big hash
	if(defined $hashTable{$word})
	{
	    $hashTable{$word}++;
	}
	# Otherwise, add to the uniqueHash
	else
	{
	    $uniqueHash{$word}++;
	}
    }
    $wordCounter++
}

# Print initial information
$types = (scalar(keys(%hashTable)) + scalar(keys(%uniqueHash)));
print "\n\n\nFiles : ";

# Print out file names
while($printCounter <= $#ARGV)
{
    print $ARGV[$printCounter];
    print " ";
    $printCounter++;
}

# Continue printing initial information
print "\nTypes : $types";
print "\nTokens: ",($#totalWords);
print "\nRatio : ",(($#totalWords) / $types);
print "\n";

# Format the printing style
format STDOUT = 
@##     @<<<<<<<<<  @######      @#.###    @#####
$rankCounter, $word,  $frequency,  $percent,   $k
.

print "\nRANK    WORD           FREQ     PERCENT         K\n";

# Sort and print the big hash
foreach $word (sort {$hashTable{$b} <=> $hashTable{$a}} %hashTable)
{
    $frequency = $hashTable{$word};
    $percent = $hashTable{$word} / $#totalWords;
    $k =  $hashTable{$word} * $rankCounter;    
    write;

    # If you hit the rank cutoff number from input
    if($rankCounter == $rankNumber)
    {
	last;
    }
    $rankCounter++;
}

# Reset rankCounter to 1
$rankCounter = 1;

$lowerTypes = (scalar(keys(%uniqueHash)));
print "\n";
print "Unique words found in last $percentText percent of the text:\n\n";
print "RANK    WORD           FREQ     PERCENT         K\n";

# Sort and print the unique hash table
foreach $word (sort{$uniqueHash{$b}<=>$uniqueHash{$a}}%uniqueHash)
{
    $frequency = $uniqueHash{$word};
    $percent = ($uniqueHash{$word}) / $lowerTypes;
    $k =  $uniqueHash{$word} * $rankCounter;
    write;

    # If you hit the rank cutoff number from input
    if($rankCounter == $rankNumber)
    {
	last;
    }
    $rankCounter++;
}
